/*----------------------------------------------------------------------------
	
	Designers Guide to the Cortex-M Family
	CMSIS RTOS Mutex Example

*----------------------------------------------------------------------------*/
#include "stm32f10x.h"
#include "cmsis_os2.h"
#include "uart.h"

void uart_Thread1 (void *argument);
void uart_Thread2 (void *argument);


osThreadId_t  T_uart1, T_uart2;
osMutexId_t uartMutex;	

/*----------------------------------------------------------------------------
 Thread two writes the character '1' to UART 1
 *---------------------------------------------------------------------------*/
 static const osThreadAttr_t ThreadAttr_LED1 = {
	.name = "LED1",
};
 
__NO_RETURN void uart_Thread1 (void  *argument) {
uint32_t i;

	for (;;) {
//		osMutexAcquire(uartMutex, osWaitForever); 
		for( i=0;i<10;i++)
		{
			SendChar('1');
		}
		SendChar('\n');
		SendChar('\r');
//		osMutexRelease(uartMutex);	
	}
}

/*----------------------------------------------------------------------------
  Thread two writes the character '2' to UART 1
 *---------------------------------------------------------------------------*/
static const osThreadAttr_t ThreadAttr_LED2 = {
	.name = "LED2",
};

__NO_RETURN void uart_Thread2 (void  *argument) {
uint32_t i;

	for(;;){
//		osMutexAcquire(uartMutex, osWaitForever);
		for( i=0;i<10;i++)
		{
			SendChar('2');
		}
		SendChar('\n');
		SendChar('\r');
//		osMutexRelease(uartMutex);
	}
}

/*----------------------------------------------------------------------------
 Initilise the USART, create the mutex and start the Threads
 *---------------------------------------------------------------------------*/
static const osMutexAttr_t MutexAttr_uartMutex = {
	.name = "uartMutex",
};

static const osThreadAttr_t ThreadAttr_main = {
	.name = "main",
};
void app_main (void *argument) {
		
	USART1_Init ();
	uartMutex = osMutexNew(&MutexAttr_uartMutex );	
	T_uart1 = osThreadNew(uart_Thread1, NULL, &ThreadAttr_LED1);
	T_uart2 = osThreadNew(uart_Thread2, NULL, &ThreadAttr_LED2);
}

int main (void) {

  SystemCoreClockUpdate();
  osKernelInitialize();                 									// Initialize CMSIS-RTOS
  osThreadNew(app_main, NULL, &ThreadAttr_main);    			// Create application main thread
  if (osKernelGetState() == osKernelReady) {
    osKernelStart();                    									// Start thread execution
  }

  while(1);
}
